<?php
/*
 * Template Name: Designer Templates
 * Description: A Page Template with a darker design.
 */
get_header();

$wc_id = (isset($_GET['postid'])) ? $_GET['postid'] : "" ;


?>

<div class="container main-content-area" id="contain" style="margin-bottom: 10px;box-shadow: 3px 3px 3px 3px black;">
	<!--header top bar starts form here-->
	<div class="row">

		<div class="site-navigation-inner col-sm-12">

			<div class="ext-customizer-navbar-header" style="margin-bottom: 0px">

				<?php $toptext = get_option('_ext_heading_text');

				if($toptext != ''){
					$toptext = get_option('_ext_heading_text');
				}else {
					$front_width= get_option('front_width');
					$front_height= get_option('front_height');
					$toptext = 'Card Designer('.$front_width.'*'.$front_height.')';
				} ?>

				<span id="ddd" class="ext-customizer-navbar-brand"><?php echo $toptext; ?></span>

			</div>

		</div>

	</div>
	<!--header top bar ends form here -->
	<!-- <div class="col-sm-12 col-md-12"> -->
	<div id="aadded_by_yasir" class="added_by_yasir"> 
		<div class="well">
			<aside id="toolslist-left" class="tools" >
				<div >
					<ul>
						<li class="tools_item">
							<a class="tools_icon" href="javascript:void(0);" onclick="addText()"><i class="fa fa-text-width"></i><span class="tools-left"><?php _e('Add Text','product-designer'); ?></span></a>
						</li>
						<li class="tools_item">
							<input type="file" id="imgupload" style="display:none;"/>
							<a class=" tools_icon" id="OpenImgUpload" name="OpenImgUpload" href="javascript:void(0);" ><i class="fa fa-image"></i><span class="tools-left"><?php _e('Upload Pictures', 'product-designer'); ?></span></a>
						</li>
						<li class="my_modal1_open tools_item">
							<a class="tools_icon" href="javascript:void(0);"><i class="fa fa-paperclip"></i><span class="tools-left" ><?php _e('Clip Arts', 'product-designer'); ?></span></a>
						</li>
						<li class="tools_item">
							<a class="tools_icon active onclickfront" href="javascript:void(0);" onclick="frontside()"><i class="fa fa-forward"></i><span class="tools-left"><?php _e('Front Side','product-designer'); ?></span></a>
						</li>
							<?php //$b_side_fuser = get_post_meta($wc_id, 'wc_card_template_data_back', true);
							//if(isset($b_side_fuser) && $b_side_fuser != '') { ?>
							<li class="tools_item">
								<a class="tools_icon onclickback " href="javascript:void(0);" onclick="backside()"><i class="fa fa-backward"></i><span class="tools-left"><?php _e('Back Side','product-designer'); ?></span></a>
							</li>
							<?php //} ?>
							<li class="tools_item">
								<a class="tools_icon" href="javascript:void(0);" onclick="user_save_tempalte()" id="user_save_front"><i class="fa fa-save"></i><span class="tools-left"><?php _e('Save Design','product-designer'); ?></span></a>
								<input type="hidden" id="template_side_wc" value="">
							</li>
							<li class="tools_item">
								<a class="tools_icon" href="javascript:void(0);" onclick="Imagedata()"><i class="fa fa-save"></i><span class="tools-left"><?php _e('Finish & Order','product-designer'); ?></span></a>
							</li>
							<?php if(isset($b_side_fuser) && $b_side_fuser != '') { ?>
							<li class="wc_img_preview">
								<img class="wc_piamges" id="front_preview">
								<img class="wc_piamges" id="back_preview">
							</li>
							<?php } else { ?>
							<li class="wc_img_preview">
								<img class="wc_piamges" id="front_preview">
								<img class="wc_piamges" id="back_preview" src="<?php echo get_option('back_side_no_image');?>">
							</li>
							<?php } ?>
							<form id="formimagedata" method="POST" action="<?php echo $_SERVER['HTTP_REFERER']; ?>">
								<input type="hidden" id="hiddenIDf" name="imagedataurlbase64['f_side']" value="" />
								<input type="hidden" id="hiddenIDb" name="imagedataurlbase64['b_side']" value="" />
							</form>
						</ul>
					</div>
				</aside>
			</div>

			<!-- </div> -->
			<!--main editor row starts form here-->
			<div class="row">

				<!-- main -->
				<!-- <div class="col-sm-12 col-md-12"> -->

				<!-- top canvas starts form here -->
				<div class="main-inner" style="background-color: <?php echo $bgcolor; ?>;">

					<div id="main-inner-content">

						<div class="tools-top">

							<select title="Select Font" id="front-familyff"></select>

							<input title="Font Size" type="number" class="fontinput" id="fontsize" name="fontsize" min="0" max="100" value="20">

							<input title="Line Height" type="number" id="textalign-heightff" value="1" min="1" max="2.5" step="0.25">

							<input type='text' id="font-colorfront" />

							<!--text alingments-->
							<a href="javascript:void(0);" id="textalign-left" title="Align Left" class="tools-top"><i class="fa fa-align-left"></i></a>

							<a href="javascript:void(0);" id="textalign-right" title="Align Right" class="tools-top"><i class="fa fa-align-right"></i></a>

							<a href="javascript:void(0);" id="textalign-justify" title="Justify" class="tools-top"><i class="fa fa-align-justify"></i></a>

							<a href="javascript:void(0);" id="textalign-center" title="Center Align" class="tools-top"><i class="fa fa-align-center"></i></a>

							<!--undo redo-->
							<a href="javascript:void(0);" id="undo" title="Undo" onclick="undo()" class="tools-top"><i class="fa fa-undo"></i></a>

							<a href="javascript:void(0);" id="redo"  title="Redo" onclick="redo()" class="tools-top"><i class="fa fa-redo"></i></a>

							<!--zoom in/out up/down left/right-->
							<a href="javascript:void(0);" id="zoomIn" title="Zoom In" class="tools-top"><i class="fa fa-search-plus"></i></a>

							<a href="javascript:void(0);" id="zoomOut" title="Zoom Out" class="tools-top"><i class="fa fa-search-minus"></i></a>

							<a href="javascript:void(0);" id="delete" title="Delete" class="tools-top"><i class="fa fa-trash"></i></a>

							<a href="javascript:void(0);" onclick="CanvasGrid()" title="Add Grid" class="tools-top"><i class="fa fa-th"></i></a>

							<a href="javascript:void(0);" onclick="RemoveGrid()" title="Remove Grid" class="tools-top"><i class="fa fa-minus-square" aria-hidden="true"></i></a>

							<a href="javascript:void(0);" title="Download PNG" class="tools-top" id="fronttemplate"><i class="fa fa-download"></i></a>

						</div>

						<div class="canvas-wrapper" >

							<div class="container" style="height: 100%;">

								<div align="center" id="canvasbox" style="height: 100%;">
									<div style="height: 25px;"></div>
									<canvas id="canvas" style="border: 1px solid #8b3dff;"></canvas>
									<div style="height: 25px;"></div>
								</div>
								<div id="frontgivloader" style="display:none;"></div>
							</div>

						</div>

					</div>

					<!-- </div> -->

				</div>



			</div>

		</div>
	</div>
	<?php get_footer(); ?>

	<!--clip art model-->
	<div id="my_modal1" class="content">
		<div class="row">
			<div class="pop-head-shapes">	
				<span><?php _e('Insert Clip Arts','product-designer'); ?></span>

				<a href="#" class="my_modal1_close">
					<button class="btn btn-danger">Close<img alt="" border="0" /></button>
				</a>

			</div>
		</div>
		<?php echo do_shortcode("[front_clipart_code]"); ?>
	</div>


	<script type="text/javascript">
// get canvas  
var canvas = new fabric.Canvas('canvas');

jQuery(window).load(function() {
	frontside();
 

	jQuery(".lower-canvas").css("left","3%");
	jQuery(".upper-canvas").css("left","3%");
	jQuery(".lower-canvas").css("box-shadow","3px 5px 3px 3px #888888");
	//jQuery(".lower-canvas").css("max-width","750px");
	//jQuery(".lower-canvas").css("max-height","750px");
	jQuery(".upper-canvas").css("box-shadow","3px 5px 3px 3px #888888");
	//jQuery(".upper-canvas").css("max-width","750px");
	//jQuery(".upper-canvas").css("max-height","750px");
});

// get save tempalte front side
function frontside() {
	jQuery('.onclickback').removeClass('active');
	jQuery('.onclickfront').addClass('active');
	jQuery('.fontinput').val(20);
	jQuery('.sp-preview-inner').css("background-color","rgb(0, 0, 0)");
	jQuery('#textalign-heightff').val(1);
	jQuery('#front-familyff').val("Times New Roman");
	jQuery('#front-familyff').css("font-family","Times New Roman");
	zoomp=0;
	jQuery('#template_side_wc').val('wc_front_side_user');
	var ajaxurl = "<?php echo admin_url( 'admin-ajax.php'); ?>";
	var myurl = window.location.href;
	const get_id_frm_url = myurl.substring(myurl.lastIndexOf('=') + 1);
	var product_id = get_id_frm_url;
	var condition = 'load_for_designfront';

	jQuery.ajax({
		url : ajaxurl,
		type : 'post',
		data : {
			action : 'loadaction_designfront',
			condition :condition,
			product_id : product_id,
		},

		success : function( response ) 
		{
			var data = response.split("##");
			var can_hw = data[1].split("-");
			canvas.clear();
			canvas.setDimensions({
				width:can_hw[0],
				height:can_hw[1]
			});
			
			canvas.loadFromJSON(data[0], canvas.renderAll.bind(canvas));
		}
	});
}

// get save tempalte back side
function backside() {
	jQuery('.onclickfront').removeClass('active');
	jQuery('.onclickback').addClass('active');
	jQuery('.fontinput').val(20);
	jQuery('.sp-preview-inner').css("background-color","rgb(0, 0, 0)");
	jQuery('#textalign-heightff').val(1);
	jQuery('#front-familyff').val("Times New Roman");
	jQuery('#front-familyff').css("font-family","Times New Roman");
	zoomp=0;
	jQuery('#template_side_wc').val('wc_back_side_user');
	var ajaxurl = "<?php echo admin_url( 'admin-ajax.php'); ?>";
	var myurl = window.location.href;
	const get_id_frm_url = myurl.substring(myurl.lastIndexOf('=') + 1);
	var product_id = get_id_frm_url;
	var condition = 'load_for_designback';

	jQuery.ajax({
		url : ajaxurl,
		type : 'post',
		data : {
			action : 'loadaction_designback',
			condition :condition,
			product_id : product_id,
		},
		success : function( response ) {
			var data = response.split("##");
			var can_hw = data[1].split("-");
			canvas.clear();
			canvas.setDimensions({
				width:can_hw[0],
				height:can_hw[1]
			});
			// canvas.backgroundImageStretch = false;
			canvas.loadFromJSON(data[0], canvas.renderAll.bind(canvas));
		}
	});
}

// delete kay to delete active obj
createListenersKeyboard();
function createListenersKeyboard() {
	document.onkeydown = onKeyDownHandler;
}
function onKeyDownHandler(event) {

	var key;
	if(window.event){
		key = window.event.keyCode;
	}
	else{
		key = event.keyCode;
	}

	switch(key){

		case 46:

		if(ableToShortcut()){

			var obj = canvas.getActiveObject();
			canvas.remove(obj);
			canvas.renderAll();
			return false;
		}

		break;

		default:

		break;
	}
}
function ableToShortcut(){
	return true;
}




//undo redo functions start from here
canvas.counter = 0;
var newleft = 0;
canvas.selection = false;

var state = [];
var mods = 0;
canvas.on(
	'object:modified', function () {
		updateModifications(true);
	},
	'object:added', function () {
		updateModifications(true);
	});
function updateModifications(savehistory) {
	if (savehistory === true) {
		myjson = JSON.stringify(canvas);
		state.push(myjson);
	}
}
function undo() {
	if (mods < state.length) {
		canvas.clear().renderAll();
		canvas.loadFromJSON(state[state.length - 1 - mods - 1]);
		canvas.renderAll();
		mods += 1;
	}
}
function redo() {
	if (mods > 0) {
		canvas.clear().renderAll();
		canvas.loadFromJSON(state[state.length - 1 - mods + 1]);
		canvas.renderAll();
		mods -= 1;
	}
}

//upload image from local
jQuery('#OpenImgUpload').click(function() {
	jQuery('#imgupload').click();
	document.getElementById('imgupload').addEventListener("change", function (e) {
		var file = e.target.files[0];
		var reader = new FileReader();
		reader.onload = function (f) {
			var data = f.target.result;                    
			fabric.Image.fromURL(data, function (img) {
				// var oImg = img.set({left: 100, top: 100,angle:0,width:img.width, height:img.height, scaleX: .1,
				// 	scaleY: .1, centeredRotation: true, 
				// });
				var oImg = img.set({left: 100, top: 100,angle:0,width:img.width, height:img.height, centeredRotation: true, 
				});
				canvas.add(oImg);
				canvas.renderAll();
				canvas.deactivateAll().renderAll();
				var a = canvas.setActiveObject(oImg);
				var dataURL = canvas.toDataURL({format: 'png', quality: 0.8});
			});
		};
		reader.readAsDataURL(file);
		document.getElementById("imgupload").value = "";
		document.getElementById("imgupload").click();

	});
});
//Canvas Grid remove and add functions.
var grid = 20;
function CanvasGrid() {
	for (var i = 0; i < (1800 / grid); i++) {
		canvas.add(new fabric.Line([i * grid, 0, i * grid, 1800], {
			stroke: '#ccc',
			selectable: false
		}));
		canvas.add(new fabric.Line([0, i * grid, 1800, i * grid], {
			stroke: '#ccc',
			selectable: false
		}));
	}
}
function RemoveGrid() {
	var objects = canvas.getObjects('line');
	for (var i in objects) {
		canvas.remove(objects[i]);
	}
	canvas.renderAll();
}

//zoom section canvas 
jQuery(function() {
	jQuery('#zoomIn').click(function() {
		//canvas.setZoom(canvas.getZoom() * 1.1 );
		//canvas.zoomToPoint(new fabric.Point(canvas.width / 2, canvas.height / 2), canvas.getZoom() * 1.1);
		if (zoomp == 5)
		{
			return;
		}

		jQuery(".upper-canvas").css('height',jQuery(".upper-canvas").outerHeight()* 2  +"px")
		jQuery(".upper-canvas").css('width',jQuery(".upper-canvas").outerWidth()* 2  +"px")
		jQuery(".lower-canvas").css('height',jQuery(".lower-canvas").outerHeight()* 2  +"px")
		jQuery(".lower-canvas").css('width',jQuery(".lower-canvas").outerWidth()* 2  +"px")
		// jQuery("#canvasbox").css("overflow","scroll");
		zoomp++;
		
		//jQuery(".canvas-container").css('height',canvas.zoomToPoint(new fabric.Point(canvas.width / 2, canvas.height / 2), canvas.getZoom() * 1.1) +"px")
		
	});
	jQuery('#zoomOut').click(function(){
		if (zoomp == 0)
		{
			return;
		}
		if (zoomp == 1) 
		{
			jQuery("#canvasbox").css("overflow","hidden");

		}
		zoomp--;
		// if (canvas.getZoom() > 1) 
		// {
			//canvas.setZoom(canvas.getZoom() / 1.1 );
			// canvas.zoomToPoint(new fabric.Point(canvas.width / 2, canvas.height / 2), canvas.getZoom() / 1.1);

			jQuery(".upper-canvas").css('height',jQuery(".upper-canvas").outerHeight() / 2  +"px")
			jQuery(".upper-canvas").css('width',jQuery(".upper-canvas").outerWidth() / 2  +"px")
			jQuery(".lower-canvas").css('height',jQuery(".lower-canvas").outerHeight() / 2  +"px")
			jQuery(".lower-canvas").css('width',jQuery(".lower-canvas").outerWidth() / 2  +"px")
			
		//}
	});
	jQuery('#delete').click(function()  {
		var obj = canvas.getActiveObject();
		if (!obj) return;
		canvas.remove(canvas.getActiveObject());
    	// canvas.getActiveObject().remove();
    });
	canvas.renderAll();
});

// //text alingments left
jQuery('#textalign-left').click(function() {
	var obj = canvas.getActiveObject();
	if(!obj) return;
	var id = jQuery(this).attr('id');
	if(id == 'textalign-left'){
    	// canvas.getActiveObject().setTextAlign('left');
    	canvas.getActiveObject().set("textAlign",'left');
    	canvas.renderAll();
    }
});
// //text alingments right
jQuery('#textalign-right').click(function() {
	var obj = canvas.getActiveObject();
	if(!obj) return;
	var id = jQuery(this).attr('id');
	if(id == 'textalign-right'){
    	// canvas.getActiveObject().setTextAlign('right');
    	canvas.getActiveObject().set("textAlign",'right');
    	canvas.renderAll();
    }
});
// //text alingments justify
jQuery('#textalign-justify').click(function() {
	var obj = canvas.getActiveObject();
	if(!obj) return;
	var id = jQuery(this).attr('id');
	if(id == 'textalign-justify'){
    	// canvas.getActiveObject().setTextAlign('justify');
    	canvas.getActiveObject().set("textAlign",'justify');
    	canvas.renderAll();
    }
});
// //text alingments center
jQuery('#textalign-center').click(function() {
	var obj = canvas.getActiveObject();
	if(!obj) return;
	var id = jQuery(this).attr('id');
	if(id == 'textalign-center'){
		canvas.getActiveObject().set("textAlign",'center');
		canvas.renderAll();
	}
});

//font size
jQuery(":input#fontsize").bind('keyup mouseup', function () {
	var obj = canvas.getActiveObject();
	if (!obj) return;
	var newVideoName = jQuery("#fontsize").val();
	canvas.getActiveObject().set("fontSize", newVideoName);
	canvas.renderAll();
});

// text lineheight
jQuery("#textalign-heightff").bind('keyup mouseup', function () {
	var obj = canvas.getActiveObject();
	if (!obj) return;
	var height = jQuery("#textalign-heightff").val();
	canvas.getActiveObject().set("lineHeight", height);
	canvas.renderAll();
});

// style the fabric object edges
fabric.Object.prototype.set({
	transparentCorners: false,
	cornerColor: '#316153',
	borderColor: '#316153',
	cornerStrokeColor : '#316153',
	cornerStyle : 'circle',
	padding : 3,
	cornerSize: 12,
	rotatingPointOffset : 20,
});

// fonts load
var fontft = ["Amatic", "Amazone", "Ballantines", "Beautifulfriday", "Beverly", "BlackKnight", "Blister", "Blocklight", "Bonnard", "BookAntiqua", "Bromello", "Brusht", "Carnival", "Carolyna", "CaviarDreams", "Chaucer", "Cheekaw", "Cinzel", "Columbia", "Comic", "Copperplate", "CarayounCrumble", "Ecuyer", "English", "Engravers", "Epoque", "Everafter", "Expect", "Gothic", "HandFree", "HappyPhantom", "Hudson", "Ikusuteito", "Isabella", "JacquesGilles", "Jerry", "Kids", "Lincoln", "Lithograph", "Malcolm", "Monotype", "Movie", "MrsEavesPetite", "Nuance", "Paradise", "Paragon", "Perpetua", "Piranesi", "PlayBillWestern", "President", "Round", "Saginaw", "SegoePrint", "SegoeScript", "Sheila", "Slender", "Snell", "SpaceToaster", "Spageti", "TrajanPro", "TypewriterBohemian", "Typewritter", "Unicorn", "William", "Zurich", "akaFrivolity", "decoGarden", "decoGatsby", "decoParkLane", "decoPlaza", "decoScore", "scriptBickham", "scriptEdward", "scriptEmbassy", "scriptFlemish", "scriptKastler", "scriptShellyAllegro", "scriptShellyVolante"];


// //adding canvas text
function addText() {
	jQuery('.fontinput').val(20);
	jQuery('#textalign-heightff').val(1);
	jQuery('.sp-preview-inner').css("background-color","#000000");
	jQuery('#front-familyff').val("Times New Roman");
	jQuery('#front-familyff').css("font-family","Times New Roman");
	var canvasCenter = canvas.getCenter('canvas');
	var oText = new fabric.IText('Lorem Ipsum', {	  
		fill: '#000000',
		fontSize:20,
		top: canvasCenter["top"],
		left: canvasCenter["left"],
		lineHeight: 1,
	});
		canvas.add(oText);
	// var objects = canvas.getActiveObject();

	 canvas.on('object:scaling', function(event) {
    if (event.target) {
      jQuery("#fontsize").val((event.target.fontSize * event.target.scaleX).toFixed(0)).change();
      event.target.fontSize= jQuery("#fontsize").val();
    }

  });

}
// first index time new roman
fontft.unshift('Times New Roman');

// Populate the fontFamily select
var select = document.getElementById("front-familyff");
fontft.forEach(function(font) {
	var option = document.createElement('option');
	option.innerHTML = font;
	option.value = font;
// fixed by Yasir
option.style.fontFamily = font; 
select.style.fontfamily = font;
option.style.color = 'black';
select.appendChild(option);
});

// Apply selected font on change
document.getElementById('front-familyff').onchange = function() {
	if (this.value !== 'Times New Roman') {
		loadAndUssf(this.value);
	} else {
		canvas.getActiveObject().set("fontFamily", this.value);
		canvas.renderAll();
	}

	this.style.fontFamily = this.value;
  	// canvas.getActiveObject().getSelectedText().set("fontFamily", this.value);
  };

// load and use the text
function loadAndUssf(font) {
	var myfont = new FontFaceObserver(font)
	myfont.load()
	.then(function() {
      // when font is loaded, use it.
      canvas.getActiveObject().set("fontFamily", font);
      canvas.renderAll();
  });
}	    
// font color
jQuery(document).ready(function() {
	let zoomp = 0;


	// jQuery(".canvas-container").css('max-height','660px');
	
	jQuery("#font-colorfront").spectrum({
		replacerClassName: 'wc-fronteditor',
		showInput: true,
		className: "full-spectrum",
		showInitial: true,
		showPalette: true,
		showSelectionPalette: true,
		maxSelectionSize: 10,
		preferredFormat: "hex",
		localStorageKey: "spectrum.demo",
		move: function (color) {
			var obj = canvas.getActiveObject();
			if (!obj) return;
	            // canvas.getActiveObject().setFill(color.toRgbString());
	            canvas.getActiveObject().set('fill',color.toRgbString());
	            canvas.renderAll();
	        },
	        show: function () {

	        },
	        beforeShow: function () {

	        },
	        hide: function () {

	        },
	        change: function() {

	        },
	        palette: [
	        ["rgb(0, 0, 0)", "rgb(67, 67, 67)", "rgb(102, 102, 102)",
	        "rgb(204, 204, 204)", "rgb(217, 217, 217)","rgb(255, 255, 255)"],
	        ["rgb(152, 0, 0)", "rgb(255, 0, 0)", "rgb(255, 153, 0)", "rgb(255, 255, 0)", "rgb(0, 255, 0)",
	        "rgb(0, 255, 255)", "rgb(74, 134, 232)", "rgb(0, 0, 255)", "rgb(153, 0, 255)", "rgb(255, 0, 255)"], 
	        ["rgb(230, 184, 175)", "rgb(244, 204, 204)", "rgb(252, 229, 205)", "rgb(255, 242, 204)", "rgb(217, 234, 211)", 
	        "rgb(208, 224, 227)", "rgb(201, 218, 248)", "rgb(207, 226, 243)", "rgb(217, 210, 233)", "rgb(234, 209, 220)", 
	        "rgb(221, 126, 107)", "rgb(234, 153, 153)", "rgb(249, 203, 156)", "rgb(255, 229, 153)", "rgb(182, 215, 168)", 
	        "rgb(162, 196, 201)", "rgb(164, 194, 244)", "rgb(159, 197, 232)", "rgb(180, 167, 214)", "rgb(213, 166, 189)", 
	        "rgb(204, 65, 37)", "rgb(224, 102, 102)", "rgb(246, 178, 107)", "rgb(255, 217, 102)", "rgb(147, 196, 125)", 
	        "rgb(118, 165, 175)", "rgb(109, 158, 235)", "rgb(111, 168, 220)", "rgb(142, 124, 195)", "rgb(194, 123, 160)",
	        "rgb(166, 28, 0)", "rgb(204, 0, 0)", "rgb(230, 145, 56)", "rgb(241, 194, 50)", "rgb(106, 168, 79)",
	        "rgb(69, 129, 142)", "rgb(60, 120, 216)", "rgb(61, 133, 198)", "rgb(103, 78, 167)", "rgb(166, 77, 121)",
	        "rgb(91, 15, 0)", "rgb(102, 0, 0)", "rgb(120, 63, 4)", "rgb(127, 96, 0)", "rgb(39, 78, 19)", 
	        "rgb(12, 52, 61)", "rgb(28, 69, 135)", "rgb(7, 55, 99)", "rgb(32, 18, 77)", "rgb(76, 17, 48)"]
	        ]
	    });
});


// get active object data
function onObjectSelected({selected}) {
	var curr_font = selected[0]['fontFamily'];
	var curr_color = selected[0]['fill'];
	var curr_size = selected[0]['fontSize'];
	var cur_linehight = selected[0]['lineHeight'];
	var objtype = selected[0]['type'];
	if(objtype !== null && objtype == "i-text" ) {
	   
	    //fontfamily
	    jQuery('#front-familyff').val(curr_font).change();

	    // fontsize
	    jQuery('#fontsize').val(curr_size);

	    // fontcolor
	    jQuery('.wc-fronteditor .sp-preview-inner').css('background-color', curr_color);

	    //lineheight
	    jQuery('#textalign-heightff').val(cur_linehight); 
	}
}
// canvas.on('object:selected', onObjectSelected);
canvas.on({
  'selection:updated': onObjectSelected,
  'selection:created': onObjectSelected
});


// front tempalte download
var imageSaver = document.getElementById('fronttemplate');
var sav = imageSaver.addEventListener('click', saveImage, false);
function saveImage(e) {
	this.href = canvas.toDataURL({
		format: 'png',
	});
	this.download = "canvas.png"
}

// front tempalte save by user
function user_save_tempalte() {
	var ajaxurl = "<?php echo admin_url( 'admin-ajax.php'); ?>";
	var json_data = JSON.stringify(canvas.toJSON());
	var myurl = window.location.href;
	const get_id_frm_url = myurl.substring(myurl.lastIndexOf('=') + 1);
	var product_id = get_id_frm_url;
	var template_side = jQuery("#template_side_wc").val();
	if(template_side === ''){
		return false;
	}else if(template_side === 'wc_front_side_user'){
		document.querySelector('#front_preview').src = canvas.toDataURL('image/png');
	}else {
		document.querySelector('#back_preview').src = canvas.toDataURL('image/png');
	}
	jQuery("#frontgivloader").show();
	var condition = 'current_user_desing_saving';
	jQuery.ajax({
		url : ajaxurl,
		type : 'post',
		data : {
			action : 'user_desingwc',
			condition :condition,
			json_data : json_data,
			product_id : product_id,
			template_side : template_side,
		},
		success : function( response ) {
			jQuery("#frontgivloader").hide(); 
		}
	});
}

// get pic and proceed for single page
function Imagedata() {						
	var wc_fside = document.getElementById('front_preview');
	var wc_bside = document.getElementById('back_preview');

	var img_f = wc_fside.src;
	var img_b = wc_bside.src;

	if (img_f == '' ) { 
		//alert("Please Finish Design befor Save and Proceed");
		return false;
	} else if(img_b == '') {
		var img_bb = jQuery("#b_side_assist").val();
		jQuery("#hiddenIDf").val(img_f);
		jQuery("#hiddenIDb").val(img_bb);
		jQuery('#formimagedata').submit();
	} else {
		jQuery("#hiddenIDf").val(img_f);
		jQuery("#hiddenIDb").val(img_b);
		jQuery('#formimagedata').submit();
	}
} 

// model popup for clip arts
jQuery(function() {

	jQuery('#my_modal1').popup();
	jQuery('.my_modal_close').click(function() {jQuery("#my_modal_background").trigger('click');});
});

</script>
