<div style="width: 100%; background-color: #D3D3D3;">
	<h1 style="text-align: center; color: black; font-size: 29px;
	font-weight: 600;">Card Designer</h1>
</div>
<div class="wc_icon-bar">
	<div style="height: 5px; width: 100%;"></div>

	<select title="Select Font" id="font-family" style="min-width: 150px; max-width: 150px;" ></select>
	<input title="Font Size" type="number" class="fontinput" id="fontsize" name="fontsize" min="1"  value="10">
	<input title="Line Height" type="number" class="fontinput" id="textalign-height" value="1" min="1" max="2.5" step="0.25">
	<input type='text' id="font-color" />

	
	<a href="javascript:void(0);" title="Add Text" onclick="wc_temp_addText()"><i class="fa fa-font"></i></a>		  
	<a href="javascript:void(0);" title="Delete" id="delete"><i class="fa fa-trash"></i></a>
	<a class="my_modal1_open" title="Add Arts" href="javascript:void(0);"><i class="fa fa-heart-o"></i></a>
	<a href="javascript:void(0);" title="Text Left" id="textalign-left" ><i class="fa fa-align-left"></i></a>
	<a href="javascript:void(0);" title="Text Center" id="textalign-center"><i class="fa fa-align-center"></i></a>
	<a href="javascript:void(0);" title="Text Right" id="textalign-right"><i class="fa fa-align-right"></i></a>
	<a href="javascript:void(0);" title="Text Justify" id="textalign-justify"><i class="fa fa-align-justify"></i></a>
	<a href="javascript:void(0);" title="Undo" id="undo" onclick="undof()"><i class="fa fa-undo"></i></a>
	<a href="javascript:void(0);" title="Redo" id="redo" onclick="redof()"><i class="fa fa-refresh"></i></a>
	<a href="javascript:void(0);" id="zoomIn" title="Zoom In" ><i class="fa fa-search-plus"></i></a>
	<a href="javascript:void(0);" id="zoomOut" title="Zoom Out" ><i class="fa fa-search-minus"></i></a>
	 <?php
    $frontwidth= get_option('front_width');
    // if(!isset($frontwidth) || $frontwidth="" ) {
    //     $frontwidth='400';
    // }
     $frontheight= get_option('front_height');
    // if(!isset($frontheight) || $frontheight == "") {
    //     $frontheight='400';
    // }
    ?>
	<label>Width : </label>
	<input  title="card width" class="card_width_front" type="number" id="card-width" value="<?php echo $frontwidth ?>" min="100" max="870">
	<label>Height : </label>

	<input  title="card height" class="card_height_front" type="number" id="card-height" value="<?php echo $frontheight?>" min="100" max="930">
	<br><br>
	<div style="height: 25px; width: 100%; border-top: 5px solid #D3D3D3 "></div>
</div>

<!-- canvas frontend template -->
<div class="w_card_template_creating" style="display: flex; align-items: center; justify-content:center;">
	<canvas id="f_template"></canvas>
</div>
<div id="divLoading" style="display:none;"></div>
<div class="wcb_bar_icon">
	<a href="javascript:void(0);" title="Cancel Editing" onclick="clearcanf();">
		<i class="fa fa fa-times fa-2x fa-border"></i>
	</a>
	<a href="javascript:void(0);" title="Insert Watermark" id="wc_water_markf">
		<i class="fa fa-tint fa-2x fa-border"></i>
	</a>
	<a href="javascript:void(0);" title="Insert background" id="we_add_front">
		<i class="fa fa-picture-o fa-2x fa-border"></i>
	</a>
	<a class="frontsave" href="javascript:void(0);" title="Save Template" onclick='exportToJson();' value="ToJson">
		<i class="fa fa-save fa-2x pull-right fa-border"></i>
	</a>
	<a href="javascript:void(0);" title="Load Save Template" onclick='loadsavetemf();' >
		<i class="fa fa-hourglass fa-2x fa-border"></i>
	</a>
	<a href="javascript:void(0);" title="Download Template" id='ftdownload' >
		<i class="fa fa-download fa-2x fa-border" aria-hidden="true"></i>
	</a>
</div>

<input type="hidden" id="wc_product_idf" value="<?php echo $post_id; ?>">

<div id="my_modal1" class="content">
	<div class="row">
		<div class="pop-head-shapes">	
			<span><?php _e('Insert Clip Arts','product-designer'); ?></span>
			<a href="#" class="my_modal1_close">
				<i class="fa fa fa-times fa-2x fa-border"></i>
			</a>
			<br>
		</div>
	</div>
	<?php echo do_shortcode("[ext_clipart_filters]"); ?>
</div>

<script type="text/javascript">

///////////////////////////////////////////////////////////////////width height//////////////////////////////////////////////
    
    jQuery(".card_width_front").keyup(function(){
        var card_width_front=jQuery('.card_width_front').val();
        jQuery('.card_width_back').val(card_width_front).change();
});
       jQuery(".card_height_front").keyup(function(){
        var card_height_front=jQuery('.card_height_front').val();
        jQuery('.card_height_back').val(card_height_front).change();
});

       //////////////////////////////////////////////////////////////////canvas width height//////////////////////////////
        jQuery(".card_width_front").change(function(){
     	var card_width_front=jQuery('.card_width_front').val();
     	var canvas_width=card_width_front;
     	if(canvas_width<100){
     		canvas_width=100
     	}
     	jQuery('.canvas-container').width(canvas_width).change();
     	jQuery('.upper-canvas').width(canvas_width).change();
     	jQuery('.lower-canvas').width(canvas_width).change();

});
           jQuery(".card_height_front").change(function(){
     	var card_height_front=jQuery('.card_height_front').val();
     	var canvas_height=card_height_front;
     	if(canvas_height<100){
     		canvas_height=100
     	}
     	jQuery('.canvas-container').height(canvas_height).change();
     	jQuery('.upper-canvas').height(canvas_height).change();
     	jQuery('.lower-canvas').height(canvas_height).change();

});

    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	var canvas = new fabric.Canvas("f_template");

	// preloaded front function
	jQuery(window).load(function() {
		loadsavetemf();
		jQuery(".lower-canvas").css("box-shadow","3px 3px 3px 3px #888888");
		jQuery(".upper-canvas").css("box-shadow","3px 3px 3px 3px #888888");
	});

	// background watermark 
	jQuery(document).ready(function($){
		// jQuery("#font-family option").css('font-family',jQuery("#font-family option").val());
		// jQuery("#font-family option").css('color','red');


		jQuery('#wc_water_markf').click(function(e) {
			e.preventDefault();
			var image = wp.media({ 
				title: 'Upload Image',
				multiple: false
			}).open()
			.on('select', function(e){
				var uploaded_image = image.state().get('selection').first();
				var myDataURL = uploaded_image.toJSON().url;
				canvas.setOverlayImage(myDataURL, function() {
					canvas.overlayImage.scaleX = canvas.width  / 1200;
					canvas.overlayImage.scaleY = canvas.height / 1200;
					canvas.overlayImage.opacity = 0.2;
					canvas.renderAll();
				});
			});
		});
	});

	// delete kay to delete active obj
	createListenersKeyboard();
	function createListenersKeyboard() {
		document.onkeydown = onKeyDownHandler;
	}
	function onKeyDownHandler(event) {

		var key;
		if(window.event){
			key = window.event.keyCode;
		}
		else{
			key = event.keyCode;
		}

		switch(key){

			case 46:

			if(ableToShortcut()){

				var obj = canvas.getActiveObject();
				canvas.remove(obj);
				canvas.renderAll();
				return false;
			}

			break;

			default:

			break;
		}
	}
	function ableToShortcut(){
		return true;
	}

	// background image 
	jQuery(document).ready(function($){

		var wrapperWidth = jQuery(".canvas-container").parent().width()-8;
		// var wrapperWidthh = jQuery(".canvas-container").parent().width();
		//jQuery(".canvas-container").css("max-height","722px");
		//jQuery(".canvas-container").css("max-width","602px");
		var get_card_width_f;
		var get_card_height_f;

		function get_width_function_f()
		{
			get_card_width_f = jQuery(".card_width_front").val();
		}
		function get_height_function_f()
		{
			get_card_height_f = jQuery(".card_height_front").val();
		}
		jQuery('.card_width_front').on('focusout', function(e)
		{
			if ($(this).val() < 100)
			{
				e.preventDefault();
				$(this).val(100);
			}
		})
		jQuery('.card_height_front').on('focusout', function(e)
		{
			if ($(this).val() < 100)
			{
				e.preventDefault();
				$(this).val(100);
			}
		})
		jQuery('.card_width_front').on('keydown keyup change', function(e){
			if ($(this).val() > 870 
        && e.keyCode !== 46 // keycode for delete
        && e.keyCode !== 8 // keycode for backspace
        ) {
				e.preventDefault();
			$(this).val(870);
			alert("Max Width can be 870px")
		}
		get_width_function_f()

	});

		jQuery('.card_height_front').on('keydown keyup change', function(e){
			if ($(this).val() > 930 
        && e.keyCode !== 46 // keycode for delete
        && e.keyCode !== 8 // keycode for backspace
        ) {
				e.preventDefault();
			$(this).val(930);
			alert("Max Height can be 930px")
		}

		get_height_function_f();
		
	});
		get_width_function_f();
		get_height_function_f();

		var imageWidth ;
		var imageHeight;

		jQuery('#we_add_front').click(function(e) {
			e.preventDefault();
			var image = wp.media({ 
				title: 'Upload Image',
				multiple: false
			}).open()
			.on('select', function(e){

				var uploaded_image = image.state().get('selection').first();
				var myDataURL = uploaded_image.toJSON().url;
				if (myDataURL.indexOf("https") < 0){
					myDataURL = myDataURL.replace("http", "https");
				}
				var img = new Image();
				img.onload = function() 
				{

					imageWidth = img.naturalWidth;
					imageHeight = img.naturalHeight;

					var aspectRatio = imageHeight / imageWidth;
					imageWidth = wrapperWidth;
					imageHeight = wrapperWidth * aspectRatio;
					var f_img = new fabric.Image(img);

					
					canvas.setDimensions({
						width:get_card_width_f,
						height:get_card_height_f
					});
					canvas.setBackgroundImage(f_img, canvas.renderAll.bind(canvas), {
						scaleX: canvas.width / img.width,
						scaleY: canvas.height / img.height
					});

					
					//canvas.setWidth(600);

					//canvas.backgroundimage.width = canvas.getWidth();
					//canvas.backgroundimage.height = canvas.getHeight();
					canvas.renderAll();
				}

				img.src = myDataURL;
			});
		});
	});

	// clear canvas
	function clearcanf() {
		canvas.clear().renderAll();
		newleft = 0;
	}

	// style the fabric object edges
	fabric.Object.prototype.set({
		transparentCorners: false,
		cornerColor: '#b114b0',
		borderColor: '#a60cc0',
		cornerStrokeColor : '#154aa0',
		cornerStyle : 'circle',
		padding : 3,
		cornerSize: 12,
		rotatingPointOffset : 20,
	});

	//font size
	jQuery(":input#fontsize").bind('keyup mouseup', function () {
		var obj = canvas.getActiveObject();
		if (!obj) return;
		var newVideoName = jQuery("#fontsize").val();
		canvas.getActiveObject().set("fontSize", newVideoName);
		canvas.renderAll();
	});

	// text lineheight
	jQuery("#textalign-height").bind('keyup mouseup', function () {
		var obj = canvas.getActiveObject();
		if (!obj) return;
		var height = jQuery("#textalign-height").val();
		canvas.getActiveObject().set("lineHeight", height);
		canvas.renderAll();
	});

	// delete Active object
	jQuery('#delete').click(function()  {
		var obj = canvas.getActiveObject();
		if (!obj) return;
		canvas.remove(canvas.getActiveObject());
    	// canvas.getActiveObject().remove();
    });

    // adding fonts
    var fonts = ["Amatic", "Amazone", "Ballantines", "Beautifulfriday", "Beverly", "BlackKnight", "Blister", "Blocklight", "Bonnard", "BookAntiqua", "Bromello", "Brusht", "Carnival", "Carolyna", "CaviarDreams", "Chaucer", "Cheekaw", "Cinzel", "Columbia", "Comic", "Copperplate", "CarayounCrumble", "Ecuyer", "English", "Engravers", "Epoque", "Everafter", "Expect", "Gothic", "HandFree", "HappyPhantom", "Hudson", "Ikusuteito", "Isabella", "JacquesGilles", "Jerry", "Kids", "Lincoln", "Lithograph", "Malcolm", "Monotype", "Movie", "MrsEavesPetite", "Nuance", "Paradise", "Paragon", "Perpetua", "Piranesi", "PlayBillWestern", "President", "Round", "Saginaw", "SegoePrint", "SegoeScript", "Sheila", "Slender", "Snell", "SpaceToaster", "Spageti", "TrajanPro", "TypewriterBohemian", "Typewritter", "Unicorn", "William", "Zurich", "akaFrivolity", "decoGarden", "decoGatsby", "decoParkLane", "decoPlaza", "decoScore", "scriptBickham", "scriptEdward", "scriptEmbassy", "scriptFlemish", "scriptKastler", "scriptShellyAllegro", "scriptShellyVolante"];

	// adding canvas text
	function wc_temp_addText() {
		var oText = new fabric.IText('Lorem Ipsum', {	  
			fill: '#000000',
			fontSize:15,
			top: 150,
			left: 250,
			lineHeight: 1,
		});
		canvas.add(oText);
	}
		 canvas.on('object:scaling', function(event) {
    if (event.target) {
      jQuery("#fontsize").val((event.target.fontSize * event.target.scaleX).toFixed(0)).change();
      event.target.fontSize= jQuery("#fontsize").val();
    }

  });


	// first index time new roman
	fonts.unshift('Times New Roman');
	
	// Populate the fontFamily select
	var select = document.getElementById("font-family");
	fonts.forEach(function(font) {
		var option = document.createElement('option');
		option.innerHTML = font;
		option.value = font;
		// fixed by Yasir
		option.style.fontFamily = font;
		option.style.color = 'black';
		select.appendChild(option);
	});

	// Apply selected font on change
	document.getElementById('font-family').onchange = function() {
		if (this.value !== 'Times New Roman') {
			loadAndUse(this.value);
		} else {
			canvas.getActiveObject().set("fontFamily", this.value);
			canvas.renderAll();
		}
		this.style.fontFamily = this.value;

	};

	// load and use the text
	function loadAndUse(font) {
		var myfont = new FontFaceObserver(font)
		myfont.load()
		.then(function() {
	      // when font is loaded, use it.
	      canvas.getActiveObject().set("fontFamily", font);
	      canvas.renderAll();
	  });
	}

	// text alingments left
	jQuery('#textalign-left').click(function() {
		var obj = canvas.getActiveObject();
		if(!obj) return;
		var id = jQuery(this).attr('id');
		if(id == 'textalign-left'){
	    	// canvas.getActiveObject().setTextAlign('left');
	    	canvas.getActiveObject().set("textAlign",'left');
	    	canvas.renderAll();
	    }
	});
	// text alingments right
	jQuery('#textalign-right').click(function() {
		var obj = canvas.getActiveObject();
		if(!obj) return;
		var id = jQuery(this).attr('id');
		if(id == 'textalign-right'){
	    	// canvas.getActiveObject().setTextAlign('right');
	    	canvas.getActiveObject().set("textAlign",'right');
	    	canvas.renderAll();
	    }
	});
	// text alingments justify
	jQuery('#textalign-justify').click(function() {
		var obj = canvas.getActiveObject();
		if(!obj) return;
		var id = jQuery(this).attr('id');
		if(id == 'textalign-justify'){
	    	// canvas.getActiveObject().setTextAlign('justify');
	    	canvas.getActiveObject().set("textAlign",'justify');
	    	canvas.renderAll();
	    }
	});
	// text alingments center
	jQuery('#textalign-center').click(function() {
		var obj = canvas.getActiveObject();
		if(!obj) return;
		var id = jQuery(this).attr('id');
		if(id == 'textalign-center'){
	    	// canvas.getActiveObject().setTextAlign('center');
	    	canvas.getActiveObject().set("textAlign",'center');
	    	canvas.renderAll();
	    }
	});

	//undo redo functions start from here
	canvas.counter = 0;
	var newleft = 0;
	canvas.selection = false;

	var state = [];
	var mods = 0;
	canvas.on(
		'object:modified', function () {
			updateModificationsf(true);
		},
		'object:added', function () {
			updateModificationsf(true);
		});

	function updateModificationsf(savehistory) {
		if (savehistory === true) {
			myjson = JSON.stringify(canvas);
			state.push(myjson);
		}
	}
	function undof() {
		if (mods < state.length) {
			canvas.clear().renderAll();
			canvas.loadFromJSON(state[state.length - 1 - mods - 1]);
			canvas.renderAll();
			mods += 1;
		}
	}
	function redof() {
		if (mods > 0) {
			canvas.clear().renderAll();
			canvas.loadFromJSON(state[state.length - 1 - mods + 1]);
			canvas.renderAll();
			mods -= 1;
		}
	}

	//zoom section canvas 
	jQuery(function() {
		
		jQuery('#zoomIn').click(function()
		{
			canvas.zoomToPoint(new fabric.Point(canvas.width / 2, canvas.height / 2), canvas.getZoom() * 1.1);	
		});

		jQuery('#zoomOut').click(function(){
			
			if (canvas.getZoom() > 1) 
			{

				canvas.zoomToPoint(new fabric.Point(canvas.width / 2, canvas.height / 2), canvas.getZoom() / 1.1);	
			}	

		});

		canvas.renderAll();
	});

	// font color
	jQuery(document).ready(function() {
		jQuery('#font-color').spectrum({
			replacerClassName: 'front-sidetc',
			showInput: true,
			className: "full-spectrum",
			showInitial: true,
			showPalette: true,
			showSelectionPalette: true,
			maxSelectionSize: 10,
			preferredFormat: "hex",
			localStorageKey: "spectrum.demo",
			move: function (color) {
				var obj = canvas.getActiveObject();
				if (!obj) return;
		            // canvas.getActiveObject().setFill(color.toRgbString());
		            canvas.getActiveObject().set('fill',color.toRgbString());
		            canvas.renderAll();
		        },
		        show: function () {

		        },
		        beforeShow: function () {

		        },
		        hide: function () {

		        },
		        change: function() {

		        },
		        palette: [
		        ["rgb(0, 0, 0)", "rgb(67, 67, 67)", "rgb(102, 102, 102)",
		        "rgb(204, 204, 204)", "rgb(217, 217, 217)","rgb(255, 255, 255)"],
		        ["rgb(152, 0, 0)", "rgb(255, 0, 0)", "rgb(255, 153, 0)", "rgb(255, 255, 0)", "rgb(0, 255, 0)",
		        "rgb(0, 255, 255)", "rgb(74, 134, 232)", "rgb(0, 0, 255)", "rgb(153, 0, 255)", "rgb(255, 0, 255)"], 
		        ["rgb(230, 184, 175)", "rgb(244, 204, 204)", "rgb(252, 229, 205)", "rgb(255, 242, 204)", "rgb(217, 234, 211)", 
		        "rgb(208, 224, 227)", "rgb(201, 218, 248)", "rgb(207, 226, 243)", "rgb(217, 210, 233)", "rgb(234, 209, 220)", 
		        "rgb(221, 126, 107)", "rgb(234, 153, 153)", "rgb(249, 203, 156)", "rgb(255, 229, 153)", "rgb(182, 215, 168)", 
		        "rgb(162, 196, 201)", "rgb(164, 194, 244)", "rgb(159, 197, 232)", "rgb(180, 167, 214)", "rgb(213, 166, 189)", 
		        "rgb(204, 65, 37)", "rgb(224, 102, 102)", "rgb(246, 178, 107)", "rgb(255, 217, 102)", "rgb(147, 196, 125)", 
		        "rgb(118, 165, 175)", "rgb(109, 158, 235)", "rgb(111, 168, 220)", "rgb(142, 124, 195)", "rgb(194, 123, 160)",
		        "rgb(166, 28, 0)", "rgb(204, 0, 0)", "rgb(230, 145, 56)", "rgb(241, 194, 50)", "rgb(106, 168, 79)",
		        "rgb(69, 129, 142)", "rgb(60, 120, 216)", "rgb(61, 133, 198)", "rgb(103, 78, 167)", "rgb(166, 77, 121)",
		        "rgb(91, 15, 0)", "rgb(102, 0, 0)", "rgb(120, 63, 4)", "rgb(127, 96, 0)", "rgb(39, 78, 19)", 
		        "rgb(12, 52, 61)", "rgb(28, 69, 135)", "rgb(7, 55, 99)", "rgb(32, 18, 77)", "rgb(76, 17, 48)"]
		        ]
		    });
	});

	// saving json template data
	function exportToJson() {
		jQuery("#divLoading").show(); 
		var ajaxurl = "<?php echo admin_url( 'admin-ajax.php'); ?>";
		var json_data = JSON.stringify(canvas.toJSON());
		var product_id = jQuery('#wc_product_idf').val();
		var cw = jQuery('#f_template').width();
		var ch = jQuery('#f_template').height();
		var condition = 'wd_card_jsondataf';
		jQuery.ajax({
			url : ajaxurl,
			type : 'post',
			data : {
				action : 'template_wdcards',
				condition :condition,
				template_data : json_data,
				wc_product_id : product_id,
				cw : cw,
				ch : ch,
			},
			success : function( response ) {
				jQuery("#divLoading").hide(); 
				location.reload();
			}
		});
	}

	// preload template front side
	function loadsavetemf() {
		var ajaxurl = "<?php echo admin_url( 'admin-ajax.php'); ?>";
		var product_id = jQuery('#wc_product_idf').val();
		var condition = 'wc_load_ftempalte';
		jQuery.ajax({
			url : ajaxurl,
			type : 'post',
			data : {
				action : 'front_load_temp',
				condition :condition,
				ftemp_id : product_id,
			},
			success : function( response ) {
				var data = response.split("##");
				var can_hw = data[1].split("-");
				if(data[0].length == '14') {
					//alert("You dont have any template saved yet");
					return false;
				} else if (data[0].length == '') {
					//alert("Please Create Template and Save");
					return false;
				} else {
					canvas.setDimensions({
						width:can_hw[0],
						height:can_hw[1]
					});
					// var oImg = data[0].set({left: 100, top: 100,angle:00,width:can_hw[0], height:can_hw[0], scaleX: .1,
					// 	scaleY: .1,
					// });
					// alert(data[0]);
					myDataURL=data[0];
					        if (myDataURL.indexOf("https") < 0){
             myDataURL = myDataURL.replace("http", "https");
       }
					canvas.loadFromJSON(myDataURL, canvas.renderAll.bind(canvas));


				}
			}
		});
	}

	// get active object data
	function onObjectSelected({selected}) {
		var curr_font = selected[0]['fontFamily'];
		var curr_color = selected[0]['fill'];
		var curr_size = selected[0]['fontSize'];
		var cur_linehight = selected[0]['lineHeight'];
		var objtype = selected[0]['type'];
		if(objtype !== null && objtype == "i-text" ) {
		    // fontfamily
	    jQuery('#font-family').val(curr_font).change();
		    // fontsize
		    jQuery('#fontsize').val(curr_size);

		    // fontcolor
		    jQuery('.front-sidetc .sp-preview-inner').css('background-color', curr_color); 

		    //line height
		    jQuery('#textalign-height').val(cur_linehight);
		}
	}
	// canvas.on('object:selected', onObjectSelected);
	canvas.on({
		'selection:updated': onObjectSelected,
		'selection:created': onObjectSelected
	});


	// front tempalte download
	document.getElementById('ftdownload').addEventListener('click', function() {
		canvas.renderAll();
		this.href = canvas.toDataURL({
			format: 'png',
			multiplier: 2,
			quality: 0.8        
		});
		this.download = "test.png";
	}, false);

	

	// responsive popup 
	jQuery(function() {
		jQuery('#my_modal1').popup();
		jQuery('.my_modal_close').click(function() {jQuery("#my_modal_background").trigger('click');});
	});
</script>

<style type="text/css">
	#f_template{
		position: absolute;
		width: 700px; height: 1200px; 

		left: 0px; top: 0px; touch-action: none; user-select: none;

	}

</style>