<div style="width: 100%; background-color: #D3D3D3;">
    <h1 style="text-align: center; color: black; font-size: 29px;
    font-weight: 600;">Card Designer</h1>
</div>
<div class="wc_icon-bar">
    <div style="height: 5px; width: 100%;"></div>
    <select title="Select Font" id="font-familyb" style="min-width: 150px; max-width: 150px;"></select>
    <input title="Font Size" type="number" class="fontinput" id="fontsizeb" name="fontsize" min="1" value="10">
    <input title="Line Height" type="number" id="textalign-heightb" value="1" min="1" max="2.5" step="0.25">
    <input type='text' id="font-colorb" />

    <a href="javascript:void(0);" title="Add Text" onclick="wc_temp_addTextb()"><i class="fa fa-font"></i></a>		  
    <a href="javascript:void(0);" title="Delete" id="deleteb"><i class="fa fa-trash"></i></a>
    <a class="my_modal2_open" title="Add Arts" href="javascript:void(0);"><i class="fa fa-heart-o"></i></a>
    <a href="javascript:void(0);" title="Text Left" id="textalign-leftb" ><i class="fa fa-align-left"></i></a>
    <a href="javascript:void(0);" title="Text Center" id="textalign-centerb"><i class="fa fa-align-center"></i></a>
    <a href="javascript:void(0);" title="Text Right" id="textalign-rightb"><i class="fa fa-align-right"></i></a>
    <a href="javascript:void(0);" title="Text Justify" id="textalign-justifyb"><i class="fa fa-align-justify"></i></a>
    <a href="javascript:void(0);" title="Undo" id="undo" onclick="undob()"><i class="fa fa-undo"></i></a>
    <a href="javascript:void(0);" title="Redo" id="redo" onclick="redob()"><i class="fa fa-repeat"></i></a>
    <a href="javascript:void(0);" id="zoomInb" title="Zoom In" ><i class="fa fa-search-plus"></i></a>
    <a href="javascript:void(0);" id="zoomOutb" title="Zoom Out" ><i class="fa fa-search-minus"></i></a>
    <?php
    $backwidth= get_option('front_width');
    if(!isset($backwidth) || $backwidth == "") {
        $backwidth='400';
    }
     $backheight= get_option('front_height');
    if(!isset($backheight) || $backheight == "" ) {
        $backheight='400';
    }
    ?>
    <label>Width : </label>
    <input  title="card width" class="card_width_back" type="number" id="card-width_back" value="<?php echo $backwidth?>" min="100" max="870">
    <label>Height : </label>
    <input  title="card height" class="card_height_back" type="number" id="card-height_back"value="<?php echo $backheight?>" min="100" max="930" >
    <br><br>
    <div style="height: 25px; width: 100%; border-top: 5px solid #D3D3D3 "></div>

</div>

<!-- canvasb frontend template -->
<div class="w_card_template_creating" style="display: flex; align-items: center; justify-content:center;">
	<canvas id="b_template"></canvas>
</div>

<div id="divLoadingb" style="display:none;"></div>
<div class="wcb_bar_icon">
    <a href="javascript:void(0);" title="Cancel Editing" onclick="clearcanb();">
       <i class="fa fa fa-times fa-2x fa-border"></i>
   </a>
   <a href="javascript:void(0);" title="Insert Watermark" id="wc_water_markb">
       <i class="fa fa-tint fa-2x fa-border"></i>
   </a>
   <a href="javascript:void(0);" title="Insert background" id="we_add_frontb">
       <i class="fa fa-picture-o fa-2x fa-border"></i>
   </a>
   <a class="backsave" href="javascript:void(0);" title="Save Template" onclick='exportToJsonb();' value="ToJsonb">
       <i class="fa fa-save fa-2x pull-right fa-border"></i>
   </a>
   <a href="javascript:void(0);" title="Load Save Template" onclick='loadsavetemb();' >
    <i class="fa fa-hourglass fa-2x fa-border"></i>
</a>
<a href="javascript:void(0);" title="Download Template" id='btdownload' >
    <i class="fa fa-download fa-2x fa-border" aria-hidden="true"></i>
</a>
</div>

<input type="hidden" id="wc_product_idb" value="<?php echo $post_id ?>">

<div id="my_modal2" class="content">
    <div class="row">
        <div class="pop-head-shapes">   
            <span><?php _e('Insert Clip Arts','product-designer'); ?></span>
            <a href="#" class="my_modal2_close">
                <i class="fa fa fa-times fa-2x fa-border"></i>
            </a>
            <br>
        </div>
    </div>
    <?php echo do_shortcode("[ext_clipart_filtersb]"); ?>
</div>

<script type="text/javascript">

///////////////////////////////////////////////////////////////////width height//////////////////////////////////////////////
    
    jQuery(".card_width_back").keyup(function(){
        var card_width_back=jQuery('.card_width_back').val();
        jQuery('.card_width_front').val(card_width_back).change();
});
       jQuery(".card_height_back").keyup(function(){
        var card_height_back=jQuery('.card_height_back').val();
        jQuery('.card_height_front').val(card_height_back).change();
});
         //////////////////////////////////////////////////////////////////canvas width height//////////////////////////////
       jQuery(".card_width_back").change(function(){
        var card_width_back=jQuery('.card_width_back').val();
        var canvas_width=card_width_back;
        if(canvas_width<100){
            canvas_width=100
        }    

        jQuery('.canvas-container').width(canvas_width).change();
        jQuery('.upper-canvas').width(canvas_width).change();
        jQuery('.lower-canvas').width(canvas_width).change();

    });

       jQuery(".card_height_back").change(function(){
        var card_height_back=jQuery('.card_height_back').val();
        var canvas_height=card_height_back;
        if(canvas_height<100){
            canvas_height=100
        }
        jQuery('.canvas-container').height(canvas_height).change();
        jQuery('.upper-canvas').height(canvas_height).change();
        jQuery('.lower-canvas').height(canvas_height).change();
    });
    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    var canvasb = new fabric.Canvas("b_template");

// preloaded back function
jQuery(window).load(function() {
    loadsavetemb();
});

// background watermark 
jQuery(document).ready(function($){
    jQuery('#wc_water_markb').click(function(e) {
        e.preventDefault();
        var image = wp.media({ 
            title: 'Upload Image',
            multiple: false
        }).open()
        .on('select', function(e){
            var uploaded_image = image.state().get('selection').first();
            var myDataURL = uploaded_image.toJSON().url;
            canvasb.setOverlayImage(myDataURL, function() {
             canvasb.overlayImage.scaleX = canvasb.width  / 1200;
             canvasb.overlayImage.scaleY = canvasb.height / 1200;
             canvasb.overlayImage.opacity = 0.2;
             canvasb.renderAll();
         });
        });
    });
});


// delete kay to delete active obj
createListenersKeyboard();
function createListenersKeyboard() {
    document.onkeydown = onKeyDownHandler;
}
function onKeyDownHandler(event) {

    var key;
    if(window.event){
        key = window.event.keyCode;
    }
    else{
        key = event.keyCode;
    }
    
    switch(key){

        case 46:
        
        if(ableToShortcut()){

            var obj = canvasb.getActiveObject();
            canvasb.remove(obj);
            canvasb.renderAll();
            return false;
        }
        
        break;
        
        default:
        
        break;
    }
}
function ableToShortcut(){
    return true;
}


// background image 
jQuery(document).ready(function($){

    var wrapperWidth = jQuery(".canvas-container").parent().width()-8;
    var get_card_width_b;
    var get_card_height_b;

    function get_width_function_b()
    {
        get_card_width_b = jQuery(".card_width_back").val();
    }
    function get_height_function_b()
    {
        get_card_height_b = jQuery(".card_height_back").val();
    }
    jQuery('.card_width_back').on('focusout', function(e)
    {
        if ($(this).val() < 100)
        {
            e.preventDefault();
            $(this).val(100);
        }
    })
    jQuery('.card_height_back').on('focusout', function(e)
    {
        if ($(this).val() < 100)
        {
            e.preventDefault();
            $(this).val(100);
        }
    })

    jQuery('.card_width_back').on('keydown keyup change', function(e){
        if ($(this).val() > 870 
        && e.keyCode !== 46 // keycode for delete
        && e.keyCode !== 8 // keycode for backspace
        ) {
            e.preventDefault();
        $(this).val(870);
        alert("Max Width can be 870px")
    }
    get_width_function_b()

});

    jQuery('.card_height_back').on('keydown keyup change', function(e){
        if ($(this).val() > 930 
        && e.keyCode !== 46 // keycode for delete
        && e.keyCode !== 8 // keycode for backspace
        ) {
            e.preventDefault();
        $(this).val(930);
        alert("Max Height can be 930px")
    }

    get_height_function_b();


});
    get_width_function_b();
    get_height_function_b();

    var imageWidth ;
    var imageHeight;
    
    

    jQuery('#we_add_frontb').click(function(e) {
        e.preventDefault();
        var image = wp.media({ 
            title: 'Upload Image',
            multiple: false
        }).open()
        .on('select', function(e){

            var uploaded_image = image.state().get('selection').first();
            var myDataURL = uploaded_image.toJSON().url;
                if (myDataURL.indexOf("https") < 0){
             myDataURL = myDataURL.replace("http", "https");
       }
            var img = new Image();

            img.onload = function() {

                imageWidth = img.naturalWidth;
                imageHeight = img.naturalHeight;

                var aspectRatio = imageHeight / imageWidth;

                imageWidth = wrapperWidth;
                imageHeight = wrapperWidth * aspectRatio;

                var f_img = new fabric.Image(img);
                canvasb.setDimensions({
                    width:get_card_width_b,
                    height:get_card_height_b
                });

                canvasb.setBackgroundImage(f_img, canvasb.renderAll.bind(canvasb), {
                    scaleX: canvasb.width / img.width,
                    scaleY: canvasb.height / img.height
                });                
                //canvasb.backgroundImage.width = canvasb.getWidth();
                //canvasb.backgroundImage.height = canvasb.getHeight();
                canvasb.renderAll();
            }
            img.src = myDataURL;

        });
    });
});

// clear canvas
function clearcanb() {
    canvasb.clear().renderAll();
    newleft = 0;
}

// style the fabric object edges
fabric.Object.prototype.set({
    transparentCorners: false,
    cornerColor: '#b114b0',
    borderColor: '#a60cc0',
    cornerStrokeColor : '#154aa0',
    cornerStyle : 'circle',
    padding : 3,
    cornerSize: 12,
    rotatingPointOffset : 20,
});

//font size
jQuery(":input#fontsizeb").bind('keyup mouseup', function () {
    var obj = canvasb.getActiveObject();
    if (!obj) return;
    var newVideoName = jQuery("#fontsizeb").val();
    canvasb.getActiveObject().set("fontSize", newVideoName);
    canvasb.renderAll();
});

// text lineheight
jQuery("#textalign-heightb").bind('keyup mouseup', function () {
    var obj = canvasb.getActiveObject();
    if (!obj) return;
    var height = jQuery("#textalign-heightb").val();
    canvasb.getActiveObject().set("lineHeight", height);
    canvasb.renderAll();
});

// delete Active object
jQuery('#deleteb').click(function()  {
	var obj = canvasb.getActiveObject();
	if (!obj) return;
	// canvasb.getActiveObject().remove();
    canvasb.remove(canvasb.getActiveObject());
});

// adding fonts
var fontss = ["Amatic", "Amazone", "Ballantines", "Beautifulfriday", "Beverly", "BlackKnight", "Blister", "Blocklight", "Bonnard", "BookAntiqua", "Bromello", "Brusht", "Carnival", "Carolyna", "CaviarDreams", "Chaucer", "Cheekaw", "Cinzel", "Columbia", "Comic", "Copperplate", "CarayounCrumble", "Ecuyer", "English", "Engravers", "Epoque", "Everafter", "Expect", "Gothic", "HandFree", "HappyPhantom", "Hudson", "Ikusuteito", "Isabella", "JacquesGilles", "Jerry", "Kids", "Lincoln", "Lithograph", "Malcolm", "Monotype", "Movie", "MrsEavesPetite", "Nuance", "Paradise", "Paragon", "Perpetua", "Piranesi", "PlayBillWestern", "President", "Round", "Saginaw", "SegoePrint", "SegoeScript", "Sheila", "Slender", "Snell", "SpaceToaster", "Spageti", "TrajanPro", "TypewriterBohemian", "Typewritter", "Unicorn", "William", "Zurich", "akaFrivolity", "decoGarden", "decoGatsby", "decoParkLane", "decoPlaza", "decoScore", "scriptBickham", "scriptEdward", "scriptEmbassy", "scriptFlemish", "scriptKastler", "scriptShellyAllegro", "scriptShellyVolante"];

// adding canvasb text
function wc_temp_addTextb() {
	var oText = new fabric.IText('Lorem Ipsum', {	  
		fill: '#000000',
		fontSize:15,
		top: 150,
		left: 250,
		lineHeight: 1,
	});
	canvasb.add(oText);
}
     canvasb.on('object:scaling', function(event) {
    if (event.target) {
      jQuery("#fontsizeb").val((event.target.fontSize * event.target.scaleX).toFixed(0)).change();
      event.target.fontSize= jQuery("#fontsizeb").val();
    }

  });

// first index time new roman
fontss.unshift('Times New Roman');

// Populate the fontFamily select
var select = document.getElementById("font-familyb");
fontss.forEach(function(font) {
 var option = document.createElement('option');
 option.innerHTML = font;
 option.value = font;
 // fixed by Yasir
 option.style.fontFamily = font; 
 option.style.color = 'black';

 select.appendChild(option);
});

// Apply selected font on change
document.getElementById('font-familyb').onchange = function() {
 if (this.value !== 'Times New Roman') {
   loadAndUsse(this.value);
} else {
   canvasb.getActiveObject().set("fontFamily", this.value);
   canvasb.renderAll();
}
this.style.fontFamily = this.value;

};

// load and use the text
function loadAndUsse(font) {
 var myfont = new FontFaceObserver(font)
 myfont.load()
 .then(function() {
      // when font is loaded, use it.
      canvasb.getActiveObject().set("fontFamily", font);
      canvasb.renderAll();
  });
}

// text alingments left
jQuery('#textalign-leftb').click(function() {
    var obj = canvasb.getActiveObject();
    if(!obj) return;
    var id = jQuery(this).attr('id');
    if(id == 'textalign-leftb'){
    	// canvasb.getActiveObject().setTextAlign('left');
        canvasb.getActiveObject().set("textAlign",'left');
        canvasb.renderAll();
    }
});
// text alingments right
jQuery('#textalign-rightb').click(function() {
    var obj = canvasb.getActiveObject();
    if(!obj) return;
    var id = jQuery(this).attr('id');
    if(id == 'textalign-rightb'){
    	// canvasb.getActiveObject().setTextAlign('right');
       canvasb.getActiveObject().set("textAlign",'right');
       canvasb.renderAll();
   }
});
// text alingments justify
jQuery('#textalign-justifyb').click(function() {
    var obj = canvasb.getActiveObject();
    if(!obj) return;
    var id = jQuery(this).attr('id');
    if(id == 'textalign-justifyb'){
    	// canvasb.getActiveObject().setTextAlign('justify');
       canvasb.getActiveObject().set("textAlign",'justify');
       canvasb.renderAll();
   }
});
// text alingments center
jQuery('#textalign-centerb').click(function() {
    var obj = canvasb.getActiveObject();
    if(!obj) return;
    var id = jQuery(this).attr('id');
    if(id == 'textalign-centerb'){
    	// canvasb.getActiveObject().setTextAlign('center');
      canvasb.getActiveObject().set("textAlign",'center');
      canvasb.renderAll();
  }
});

//undo redo functions start from here
canvasb.counter = 0;
var newleft = 0;
canvasb.selection = false;

var states = [];
var modsb = 0;
canvasb.on(
    'object:modified', function () {
        updateModificationsb(true);
    },
    'object:added', function () {
        updateModificationsb(true);
    });

function updateModificationsb(savehistory) {
    if (savehistory === true) {
        myjson = JSON.stringify(canvasb);
        states.push(myjson);
    }
}
function undob() {
	if (modsb < states.length) {
        canvasb.clear().renderAll();
        canvasb.loadFromJSON(states[states.length - 1 - modsb - 1]);
        canvasb.renderAll();
        modsb += 1;
    }
}
function redob() {
    if (modsb > 0) {
        canvasb.clear().renderAll();
        canvasb.loadFromJSON(states[states.length - 1 - modsb + 1]);
        canvasb.renderAll();
        modsb -= 1;
    }
}

//zoom section canvasb 
jQuery(function() {

    jQuery('#zoomInb').click(function() {
        canvasb.zoomToPoint(new fabric.Point(canvasb.width / 2, canvasb.height / 2), canvasb.getZoom() * 1.1);    });
    
    jQuery('#zoomOutb').click(function(){
        if (canvasb.getZoom() > 1) 
        {
            canvasb.zoomToPoint(new fabric.Point(canvasb.width / 2, canvasb.height / 2), canvasb.getZoom() / 1.1);        
        }

    });

    canvasb.renderAll();
});

// font color
jQuery(document).ready(function() {
	jQuery('#font-colorb').spectrum({
		replacerClassName: 'front-sidebc',
        showInput: true,
        className: "full-spectrum",
        showInitial: true,
        showPalette: true,
        showSelectionPalette: true,
        maxSelectionSize: 10,
        preferredFormat: "hex",
        localStorageKey: "spectrum.demo",
        move: function (color) {
            var obj = canvasb.getActiveObject();
            if (!obj) return;
            canvasb.getActiveObject().set('fill',color.toRgbString());
            canvasb.renderAll();
        },
        show: function () {

        },
        beforeShow: function () {

        },
        hide: function () {

        },
        change: function() {

        },
        palette: [
        ["rgb(0, 0, 0)", "rgb(67, 67, 67)", "rgb(102, 102, 102)",
        "rgb(204, 204, 204)", "rgb(217, 217, 217)","rgb(255, 255, 255)"],
        ["rgb(152, 0, 0)", "rgb(255, 0, 0)", "rgb(255, 153, 0)", "rgb(255, 255, 0)", "rgb(0, 255, 0)",
        "rgb(0, 255, 255)", "rgb(74, 134, 232)", "rgb(0, 0, 255)", "rgb(153, 0, 255)", "rgb(255, 0, 255)"], 
        ["rgb(230, 184, 175)", "rgb(244, 204, 204)", "rgb(252, 229, 205)", "rgb(255, 242, 204)", "rgb(217, 234, 211)", 
        "rgb(208, 224, 227)", "rgb(201, 218, 248)", "rgb(207, 226, 243)", "rgb(217, 210, 233)", "rgb(234, 209, 220)", 
        "rgb(221, 126, 107)", "rgb(234, 153, 153)", "rgb(249, 203, 156)", "rgb(255, 229, 153)", "rgb(182, 215, 168)", 
        "rgb(162, 196, 201)", "rgb(164, 194, 244)", "rgb(159, 197, 232)", "rgb(180, 167, 214)", "rgb(213, 166, 189)", 
        "rgb(204, 65, 37)", "rgb(224, 102, 102)", "rgb(246, 178, 107)", "rgb(255, 217, 102)", "rgb(147, 196, 125)", 
        "rgb(118, 165, 175)", "rgb(109, 158, 235)", "rgb(111, 168, 220)", "rgb(142, 124, 195)", "rgb(194, 123, 160)",
        "rgb(166, 28, 0)", "rgb(204, 0, 0)", "rgb(230, 145, 56)", "rgb(241, 194, 50)", "rgb(106, 168, 79)",
        "rgb(69, 129, 142)", "rgb(60, 120, 216)", "rgb(61, 133, 198)", "rgb(103, 78, 167)", "rgb(166, 77, 121)",
        "rgb(91, 15, 0)", "rgb(102, 0, 0)", "rgb(120, 63, 4)", "rgb(127, 96, 0)", "rgb(39, 78, 19)", 
        "rgb(12, 52, 61)", "rgb(28, 69, 135)", "rgb(7, 55, 99)", "rgb(32, 18, 77)", "rgb(76, 17, 48)"]
        ]
    });
});

// saving json template data backsite
function exportToJsonb() {
    jQuery("#divLoadingb").show(); 
    var ajaxurl = "<?php echo admin_url( 'admin-ajax.php'); ?>";
    var json_data = JSON.stringify(canvasb.toJSON());
    var product_id = jQuery('#wc_product_idb').val();
    var cw = jQuery('#b_template').width();
    var ch = jQuery('#b_template').height();
    var condition = 'wd_card_jsondatab';
    jQuery.ajax({
       url : ajaxurl,
       type : 'post',
       data : {
        action : 'template_wdcardsb',
        condition :condition,
        template_data : json_data,
        wc_product_id : product_id,
        cw : cw,
        ch : ch
    },
    success : function( response ) {
       jQuery("#divLoadingb").hide();
       location.reload(); 
   }
});
}

// preload template back side
function loadsavetemb() {
    var ajaxurl = "<?php echo admin_url( 'admin-ajax.php'); ?>";
    var product_id = jQuery('#wc_product_idb').val();
    var condition = 'wc_load_btempalte';
    jQuery.ajax({
        url : ajaxurl,
        type : 'post',
        data : {
            action : 'back_load_temp',
            condition :condition,
            btemp_id : product_id,
        },
        success : function( response ) {
            var data = response.split("##");
            var can_hw = data[1].split("-");
            if(data[0].length == '14') {
               // alert("You dont have any template saved yet");
               return false;
           } else if (data[0].length == '') {
                //alert("Please Create Template and Save");
                return false;
            } else {
                canvasb.setDimensions({
                    width:can_hw[0],
                    height:can_hw[1]
                });
                            myDataURL=data[0];
                            if (myDataURL.indexOf("https") < 0){
             myDataURL = myDataURL.replace("http", "https");
       }
                canvasb.loadFromJSON(myDataURL, canvasb.renderAll.bind(canvasb));
            }
        }
    });
}

// get active object data
function onObjectSelected({selected}) {
    var curr_font = selected[0]['fontFamily'];
    var curr_color = selected[0]['fill'];
    var curr_size = selected[0]['fontSize'];
    var cur_linehight = selected[0]['lineHeight'];
    var objtype = selected[0]['type'];
    if(objtype !== null && objtype == "i-text" ) {
        // fontfamily
        jQuery('#font-familyb').val(curr_font).change();
        // fontsize
        jQuery('#fontsizeb').val(curr_size);

        // fontcolor
        jQuery('.front-sidebc .sp-preview-inner').css('background-color', curr_color); 

        //line height
        jQuery('#textalign-heightb').val(cur_linehight);
    }
}
// canvasb.on('object:selected', onObjectSelected);
    canvasb.on({
        'selection:updated': onObjectSelected,
        'selection:created': onObjectSelected
    });


// back tempalte download
document.getElementById('btdownload').addEventListener('click', function() {
  canvasb.renderAll();
  this.href = canvasb.toDataURL({
    format: 'png',
    multiplier: 2,
    quality: 0.8        
});
  this.download = "test.png";
}, false);
// responsive popup 
jQuery(function() {
    jQuery('#my_modal2').popup();
    jQuery('.my_moda2_close').click(function() {jQuery("#my_modal_background").trigger('click');});
});

</script>
